//
//FollowLine.mm
//
//Automatically created through MiEditCLFSM -- do not change manually!
//
#include "FollowLine_Includes.h"
#include "FollowLine.h"

#include "State_INITIAL.h"
#include "State_TURN_ON_ENCODERS.h"
#include "State_GET_MAX_SPEED_AND_CAMERA_WIDTH.h"
#include "State_FEEDBACK_CONTROL.h"
#include "State_SET_MOTORS_SPEED.h"

using namespace FSM;
using namespace CLM;
extern "C"
{
	FollowLine *CLM_Create_FollowLine(int mid, const char *name)
	{
		return new FollowLine(mid, name);
	}
}

FollowLine::FollowLine(int mid, const char *name): CLMachine(mid, name)
{
	_states[0]  = new FSMFollowLine::State:: INITIAL;
	_states[1]  = new FSMFollowLine::State:: TURN_ON_ENCODERS;
	_states[2]  = new FSMFollowLine::State:: GET_MAX_SPEED_AND_CAMERA_WIDTH;
	_states[3]  = new FSMFollowLine::State:: FEEDBACK_CONTROL;
	_states[4]  = new FSMFollowLine::State:: SET_MOTORS_SPEED;

	setInitialState(_states[0]);            // set initial state
}

FollowLine::~FollowLine()
{
	delete _states[0];
	delete _states[1];
	delete _states[2];
	delete _states[3];
	delete _states[4];
}
